;USER1.ASM for LA32X00/64X00/128X00
;A very basic example that simply changes the clock rate every 
;capture cycle.  This is an example of how to change the parameters
;for the acquisition cycle.
;The code follows the label USER:

;First is the data area and data definitions for the logic parameters.

;USER.ASM data area is 4K in size.  Do not change this size.
;Please refer to main program to understand all parameters.

C2SEG  SEGMENT PUBLIC 'CODE2'
SUBRT2	PROC	FAR
	ASSUME	CS:C2SEG
	PUBLIC	 MARKER,VERSION,CHANGE,LAMODE,CLOCKRATE
	PUBLIC	 B1THV1,B1THV2,B2THV1,B2THV2,B3THV1,B3THV2,B4THV1,B4THV2,ZOOM99,GO99,ACQUIRE99,BACKUPDTA
	PUBLIC	 UB1TRIGGER0,UEXTERL,UEXTER
	PUBLIC	 TRILOGIC,USEARCH,UDISPLAY
	PUBLIC	 UMOVE,UMOVECOLOR,CURAPOS,CURBPOS,CURTPOS,SCRPOS,TRIOFFSET
	PUBLIC	 DSEGMENT,CLOCKSOURCE,SEQUENCE99
	PUBLIC	 USEREND,USER,UIOV12,UIOV34,UWINDOW
	PUBLIC	 UMO5,UMO9,UMO6,UMO10,UMO7,UMO11,UMO8,UMO12,UMETHOD
        PUBLIC   USTATE ,USTATE1,uprintset
	PUBLIC	 UBMAINCOLO,UMAINCOLO ,UMAINCOLO1, UFMAINCOLO,UBtimeCOLO, UBWINDOWCOLO , UWINDOWCOLO, UWINDOWCOLO1
	PUBLIC	 USELECTCOLO, UFSELECTCOLO ,USHADOWCOLO,UBORDERCOLO,ULMODE



;MARKER:	    3 BYTES	 ;C IN LOW BYTE
MARKER	DB	    'C','L','K'
;VERSION:	    3 INTEGER	  ;IT MEANS 08,21,1992
VERSION DB	    08,21,92
;CHANGE SETTING:    1 INTEGER	;1=YES	0=NO	    PROGRAM WILL CHANGE SETTING AND DATA IF THIS PARAMETER IS YES,PROGRAM DEFAULT 'NO'.
CHANGE	DB	    0
;LOGIC MODE:	    1 INTEGER	1=LOGIC  2=PATTERN  3=PATTERN+L.A.
LAMODE	DB	    1
;LOGIC CONFIGURATION OF BOARD1 TO 4
UMO5	DB   1	 ;1=LOGIC ANALYZER 2=PATTERN GENERATOR OF BOARD 1 CH16-31
UMO9	DB   1	 ;1=LOGIC ANALYZER 2=PATTERN GENERATOR OF BOARD 1 CH0-15
UMO6	DB   1	 ;1=LOGIC ANALYZER 2=PATTERN GENERATOR OF BOARD 2 CH16-31
UMO10	DB   1	 ;1=LOGIC ANALYZER 2=PATTERN GENERATOR OF BOARD 2 CH0-15
UMO7	DB   1	 ;1=LOGIC ANALYZER 2=PATTERN GENERATOR OF BOARD 3 CH16-31
UMO11	DB   1	 ;1=LOGIC ANALYZER 2=PATTERN GENERATOR OF BOARD 3 CH0-15
UMO8	DB   1	 ;1=LOGIC ANALYZER 2=PATTERN GENERATOR OF BOARD 4 CH16-31
UMO12	DB   1	 ;1=LOGIC ANALYZER 2=PATTERN GENERATOR OF BOARD 4 CH0-15

;OUTPUT METHOD OF LOGIC OR PATTERN GENERATOR
UMETHOD  DB	1


;CLOCK SOURCE	    1 INTEGER	;1=INTERNAL  2=EXT. CLOCK0 RISING 3=EXT. CLOCK0 FALLING 4=USER_DEFINE
CLOCKSOURCE  DB     1
;USER DEFINE EXTERNAL CLOCK
UEXTER	DB	'XXXXXXXX'
	DB	'XXXXXXXX'
	DB	'XXXXXXXX'
	DB	'XXXXXXXX'
	DB	'XXXXXXXX'
	DB	'XXXXXXXX'
	DB	'XXXXXXXX'
	DB	'XXXXXXXX'
	DB	'XXXXXXXX'
	DB	'XXXXXXXX'
	DB	'XXXXXXXX'
	DB	'XXXXXXXX'
	DB	'XXXXXXXX'
	DB	'XXXXXXXX'
	DB	'XXXXXXXX'
	DB	'XXXXXXXX'
;USER DEFINE EXTERNAL CLOCK LOGIC MODE.  1=POSITIVE LOGIC 2=NEGATIVE LOGIC
UEXTERL DB	1

;CLOCK RATE:	    1 INTEGER	;1=400MHZ  2=200MHZ  3=100MHZ.............    20=200HZ.
CLOCKRATE    DB     3
;ZOOM:		    1 INTEGER	;1=1/32   2=1/16......	   12=64
ZOOM99	     DB     6
;GO		    1 INTEGER	;1=STOP CAPTURE DATA  2=GO TO CAPTURE DATA.
GO99	     DB     1
;DISPLAY:	    1 INTEGER  1=STATE 2=TIMING 24 CH  3=TIMING 12 CH.
UDISPLAY      DB    2
;ACQUIRE	    1 INTEGER	;1=ONCE 2=REPEAT ON TRIGGER 3=REPEAT RANDOMLY.
ACQUIRE99    DB     1
;BACKUP DATA	    1 INTEGER	;1=NO  2=YES
BACKUPDTA    DB     1
;TRIGGER0-15	    35 ASCII CODE  ;0,1,X INPUT ONLY.	BOARD1 TO 4  TOTAL 64 LINES
UB1TRIGGER0    DB     'XXXXXXXX XXXXXXXX XXXXXXXX XXXXXXXX'
	   DB	  'XXXXXXXX XXXXXXXX XXXXXXXX XXXXXXXX'
	   DB	  'XXXXXXXX XXXXXXXX XXXXXXXX XXXXXXXX'
	   DB	  'XXXXXXXX XXXXXXXX XXXXXXXX XXXXXXXX'
	   DB	  'XXXXXXXX XXXXXXXX XXXXXXXX XXXXXXXX'
	   DB	  'XXXXXXXX XXXXXXXX XXXXXXXX XXXXXXXX'
	   DB	  'XXXXXXXX XXXXXXXX XXXXXXXX XXXXXXXX'
	   DB	  'XXXXXXXX XXXXXXXX XXXXXXXX XXXXXXXX'
	   DB	  'XXXXXXXX XXXXXXXX XXXXXXXX XXXXXXXX'
	   DB	  'XXXXXXXX XXXXXXXX XXXXXXXX XXXXXXXX'
	   DB	  'XXXXXXXX XXXXXXXX XXXXXXXX XXXXXXXX'
	   DB	  'XXXXXXXX XXXXXXXX XXXXXXXX XXXXXXXX'
	   DB	  'XXXXXXXX XXXXXXXX XXXXXXXX XXXXXXXX'
	   DB	  'XXXXXXXX XXXXXXXX XXXXXXXX XXXXXXXX'
	   DB	  'XXXXXXXX XXXXXXXX XXXXXXXX XXXXXXXX'
	   DB	  'XXXXXXXX XXXXXXXX XXXXXXXX XXXXXXXX'

UB2TRIGGER0    DB     'XXXXXXXX XXXXXXXX XXXXXXXX XXXXXXXX'
	   DB	  'XXXXXXXX XXXXXXXX XXXXXXXX XXXXXXXX'
	   DB	  'XXXXXXXX XXXXXXXX XXXXXXXX XXXXXXXX'
	   DB	  'XXXXXXXX XXXXXXXX XXXXXXXX XXXXXXXX'
	   DB	  'XXXXXXXX XXXXXXXX XXXXXXXX XXXXXXXX'
	   DB	  'XXXXXXXX XXXXXXXX XXXXXXXX XXXXXXXX'
	   DB	  'XXXXXXXX XXXXXXXX XXXXXXXX XXXXXXXX'
	   DB	  'XXXXXXXX XXXXXXXX XXXXXXXX XXXXXXXX'
	   DB	  'XXXXXXXX XXXXXXXX XXXXXXXX XXXXXXXX'
	   DB	  'XXXXXXXX XXXXXXXX XXXXXXXX XXXXXXXX'
	   DB	  'XXXXXXXX XXXXXXXX XXXXXXXX XXXXXXXX'
	   DB	  'XXXXXXXX XXXXXXXX XXXXXXXX XXXXXXXX'
	   DB	  'XXXXXXXX XXXXXXXX XXXXXXXX XXXXXXXX'
	   DB	  'XXXXXXXX XXXXXXXX XXXXXXXX XXXXXXXX'
	   DB	  'XXXXXXXX XXXXXXXX XXXXXXXX XXXXXXXX'
	   DB	  'XXXXXXXX XXXXXXXX XXXXXXXX XXXXXXXX'


UB3TRIGGER0    DB     'XXXXXXXX XXXXXXXX XXXXXXXX XXXXXXXX'
	   DB	  'XXXXXXXX XXXXXXXX XXXXXXXX XXXXXXXX'
	   DB	  'XXXXXXXX XXXXXXXX XXXXXXXX XXXXXXXX'
	   DB	  'XXXXXXXX XXXXXXXX XXXXXXXX XXXXXXXX'
	   DB	  'XXXXXXXX XXXXXXXX XXXXXXXX XXXXXXXX'
	   DB	  'XXXXXXXX XXXXXXXX XXXXXXXX XXXXXXXX'
	   DB	  'XXXXXXXX XXXXXXXX XXXXXXXX XXXXXXXX'
	   DB	  'XXXXXXXX XXXXXXXX XXXXXXXX XXXXXXXX'
	   DB	  'XXXXXXXX XXXXXXXX XXXXXXXX XXXXXXXX'
	   DB	  'XXXXXXXX XXXXXXXX XXXXXXXX XXXXXXXX'
	   DB	  'XXXXXXXX XXXXXXXX XXXXXXXX XXXXXXXX'
	   DB	  'XXXXXXXX XXXXXXXX XXXXXXXX XXXXXXXX'
	   DB	  'XXXXXXXX XXXXXXXX XXXXXXXX XXXXXXXX'
	   DB	  'XXXXXXXX XXXXXXXX XXXXXXXX XXXXXXXX'
	   DB	  'XXXXXXXX XXXXXXXX XXXXXXXX XXXXXXXX'
	   DB	  'XXXXXXXX XXXXXXXX XXXXXXXX XXXXXXXX'

UB4TRIGGER0    DB     'XXXXXXXX XXXXXXXX XXXXXXXX XXXXXXXX'
	   DB	  'XXXXXXXX XXXXXXXX XXXXXXXX XXXXXXXX'
	   DB	  'XXXXXXXX XXXXXXXX XXXXXXXX XXXXXXXX'
	   DB	  'XXXXXXXX XXXXXXXX XXXXXXXX XXXXXXXX'
	   DB	  'XXXXXXXX XXXXXXXX XXXXXXXX XXXXXXXX'
	   DB	  'XXXXXXXX XXXXXXXX XXXXXXXX XXXXXXXX'
	   DB	  'XXXXXXXX XXXXXXXX XXXXXXXX XXXXXXXX'
	   DB	  'XXXXXXXX XXXXXXXX XXXXXXXX XXXXXXXX'
	   DB	  'XXXXXXXX XXXXXXXX XXXXXXXX XXXXXXXX'
	   DB	  'XXXXXXXX XXXXXXXX XXXXXXXX XXXXXXXX'
	   DB	  'XXXXXXXX XXXXXXXX XXXXXXXX XXXXXXXX'
	   DB	  'XXXXXXXX XXXXXXXX XXXXXXXX XXXXXXXX'
	   DB	  'XXXXXXXX XXXXXXXX XXXXXXXX XXXXXXXX'
	   DB	  'XXXXXXXX XXXXXXXX XXXXXXXX XXXXXXXX'
	   DB	  'XXXXXXXX XXXXXXXX XXXXXXXX XXXXXXXX'
	   DB	  'XXXXXXXX XXXXXXXX XXXXXXXX XXXXXXXX'

;SEQUENCES:	    16 BYTES  ASCII CODE     ;'0123456789ABCDEFX ' INPUT ONLY.  ;FROM LEVEL0 TO 15.
SEQUENCE99    DB    '0XXXXXXXXXXXXXXX'
;TRIGGER LOGIC:     1 INTEGER  1=TRUE	2=FALSE.
TRILOGIC      DB    1
;SEARCH:	    35 ASCII CODE  ;0,1,X INPUT ONLY.
USEARCH       DB    'XXXXXXXX XXXXXXXX XXXXXXXX XXXXXXXX'
;THRESHOLD VOLTAGE1,2 OF BOARD 1 TO 4:	 1 INTEGER    FORMULA  THRESHOLD VOLTAGE=1.45+0.097(157-N)    EX. DEFAULT  N=157
; RESULT:  VOLTAGE=1.45V     ;VOLTAGE RANGE FROM -8V TO 14V   EX. 0FFH IS INHIBIT.
B1THV1	       DB     080H+29
B1THV2	       DB     080H+29
B2THV1	       DB     080H+29
B2THV2	       DB     080H+29
B3THV1	       DB     080H+29
B3THV2	       DB     080H+29
B4THV1	       DB     080H+29
B4THV2	       DB     080H+29

;MOVE:		    1 INTEGER  1=CURSOR A   2=CURSOR B	3=SCREEN H   4=TRIGGER	  5=SCREEN V
UMOVE	      DB    4
;MOVE COLOR	    5 BYTES  ;PLS REFER E.G.A. COLOR SET MODE 10.
UMOVECOLOR     DB    07H,0BH,09H,0CH,09
;CURSORA POSITION   2 BYTES    IN MEMORY      CURSORA ADDRESS IN SCREEN=CURSORA ADDRESS IN MEMORY -16
CURAPOS       DW    390
;CURSORB POSITION   2 BYTES    IN MEMORY      CURSORB ADDRESS IN SCREEN=CURSORB ADDRESS IN MEMORY -16
CURBPOS       DW    500
;CURSORT POSITION   2 BYTES    IN MEMORY      CURSORT ADDRESS IN SCREEN=CURSORT ADDRESS IN MEMORY -16
CURTPOS       DW    450
;SCREEN  POSITION   2 BYTES    IN MEMORY      CURSORS ADDRESS IN SCREEN=CURSORS ADDRESS IN MEMORY -16
SCRPOS	      DW    300
;TRIGGER OFFSET     2 BYTES  ;CALIBRATION TRIGGER POSITION BECAUSE HARDWARE DELAY AFTER TRIGGER.
TRIOFFSET     DW    0	     ;REAL CURTPOS ADDRESS=CURTPOS-TRIOFFSET	;SET TRIOFFSET IF CHANGE=1
			     ;REAL CURAPOS ADDRESS=CURAPOS-TRIOFFSET
			     ;REAL CURBPOS ADDRESS=CURBPOS-TRIOFFSET

uprintset db      0    ;1=epson 2=hp laser printer


UIOV12	      DB   7H	 ;ONE OF 4 ADDRESS BLOCK TO CONTROL I/O OF THIS CARDS.
		       ;1=0B80H,2=0B20H,3=0B00H,4=0AA0H,5=0A80H,6=0A30H,7=0A10H
UIOV34	      DB   7H	 ;BOARD 3-4 I/O ADDRESS


UWINDOW     DB	   0	;1=NO WINDOW ON  2=WINDOW ON


;ALL COLOR IN SCREEN
; 0 BLACK   4 RED	8 DARK GRAY    C LIGHT RED
; 1 BLUE    5 MAGENTA	9 LIGHT BLUE   D LIGHT MAGENTA
; 2 GREEN   6 BROWN	A LIGHT GREEN  E YELLOW
; 3 CYAN    7 WHITE	B LIGHT CYAN   F INTENS. WHITE
UBMAINCOLO	DB	0  ;	 Main menu background
UMAINCOLO	DB	0  ;	 Main menu parameter
UMAINCOLO1	DB	0  ;	 Main menu character
UFMAINCOLO	DB	0  ;	 Main menu HOT KEY
UBtimeCOLO	DB	0  ;	 Channel name background
UBWINDOWCOLO	DB	0  ;	    Window background
UWINDOWCOLO	DB	0  ;	    Window character
UWINDOWCOLO1	DB	0  ;	    Window parameter
USELECTCOLO	DB	0  ;	    Window item
UFSELECTCOLO	DB	0  ;	    Window HOT KEY
USHADOWCOLO	DB	0  ;	    Window shadow
UBORDERCOLO	DB	0  ;	    Window border



;DATA SEGMENT:	  DS=CS+3000H	2 BYTES   FOR OUTPUT ONLY
DSEGMENT  DW	  0000

USTATE	DB	1  ;INPUT FROM ATE PROGRAM  ;REMARK:ATE SYSTEM=ATE CONTROL+USER.BIN
USTATE1 DW	1  ;OUTPUT TO ATE PROGRAM  ;REMARK:ATE SYSTEM=ATE CONTROL+USER.BIN

ULMODE	 DB	1    ;1 MEANS CLK-32400  2 MEANS CLK-64400     3 MEANS CLK-128400
		    ;4 MEANS CLK-32P	 5 MEANS CLK-32200     6 MEANS CLK-64200
		    ;7 MEANS CLK-128200  8 DEFINE FOR 32 CHANNEL
SPARE	DB	32 DUP(?)     ;PREPARE FOR FUTURE VERSION
;ADDRESS OF DATA IS FOLLOWING:


;FOR 32200 AND 32400
;-----------------------------------------------
;32 CHANNEL 25 HZ TO 50 MHZ FOR 32200
;32 CHANNEL 50 HZ TO 100 MHZ FOR 32400


;4K/EVERY CHANNEL
;CH0 TO CH7	 ADDRESS   00000H
;CH8 TO CH15	 ADDRESS   01000H
;CH16 TO CH23	 ADDRESS   02000H
;CH24 TO CH31	 ADDRESS   03000H


;BACKUP DATA
;CH0 TO CH7	 ADDRESS   04000H
;CH8 TO CH15	 ADDRESS   05000H
;CH16 TO CH23	 ADDRESS   06000H
;CH24 TO CH31	 ADDRESS   07000H
;-------------------------------------------------


;16 CHANNEL 100MHZ FOR 32200
;16 CHANNEL 200MHZ FOR 32400

;8K/EVERY CHANNEL
;CH0 TO CH7	ADDRESS   00000H
;CH8 TO CH15	ADDRESS   02000H

;BACKUP DATA
;CH0 TO CH7	ADDRESS   04000H
;CH8 TO CH15	ADDRESS   06000H

;-------------------------------------------------

;8 CHANNEL 200MHZ FOR 32200
;8 CHANNEL 400MHZ FOR 32400

;16K/EVERY CHANNEL
;CH0 TO CH7	ADDRESS   00000H

;BACKUP DATA
;CH0 TO CH7	ADDRESS   04000H

;--------------------------------------------------


;FOR 64200 AND 64400
;-----------------------------------------------
;64 CHANNEL 25 HZ TO 50 MHZ FOR 64200
;64 CHANNEL 50 HZ TO 100 MHZ FOR 64400


;4K/EVERY CHANNEL
;BOARD1:
;CH0 TO CH7	 ADDRESS   00000H
;CH8 TO CH15	 ADDRESS   01000H
;CH16 TO CH23	 ADDRESS   02000H
;CH24 TO CH31	 ADDRESS   03000H

;BOARD2:
;CH0 TO CH7	 ADDRESS   04000H
;CH8 TO CH15	 ADDRESS   05000H
;CH16 TO CH23	 ADDRESS   06000H
;CH24 TO CH31	 ADDRESS   07000H

;BACKUP DATA
;BOARD1:
;CH0 TO CH7	 ADDRESS   08000H
;CH8 TO CH15	 ADDRESS   09000H
;CH16 TO CH23	 ADDRESS   0A000H
;CH24 TO CH31	 ADDRESS   0B000H
;BOARD2:
;CH0 TO CH7	 ADDRESS   0C000H
;CH8 TO CH15	 ADDRESS   0D000H
;CH16 TO CH23	 ADDRESS   0E000H
;CH24 TO CH31	 ADDRESS   0F000H


;32 CHANNEL 100MHZ FOR 64200
;32 CHANNEL 200MHZ FOR 64400

;8K/EVERY CHANNEL
;BOARD1:
;CH0 TO CH7	ADDRESS   00000H
;CH8 TO CH15	ADDRESS   02000H

;BOARD2:
;CH0 TO CH7	ADDRESS   04000H
;CH8 TO CH15	ADDRESS   06000H


;BACKUP DATA
;BOARD1:
;CH0 TO CH7	ADDRESS   08000H
;CH8 TO CH15	ADDRESS   0A000H

;BOARD2:
;CH0 TO CH7	ADDRESS   0C000H
;CH8 TO CH15	ADDRESS   0E000H

;-------------------------------------------------

;8 CHANNEL 200MHZ FOR 64200
;8 CHANNEL 400MHZ FOR 64400

;16K/EVERY CHANNEL
;BOARD1:
;CH0 TO CH7	ADDRESS   00000H
;BOARD2:
;CH0 TO CH7	ADDRESS   04000H

;BACKUP DATA
;BOARD1:
;CH0 TO CH7	ADDRESS   08000H
;BOARD2:
;CH0 TO CH7	ADDRESS   0C000H

;--------------------------------------------------

USER:
;WRITE YOUR PROGRAM HERE!
;COMPILE USER.ASM TO USER.BIN BY MASM,LINK AND EXE2BIN.

;**********************************************************
;DO NOT MODIFY THE LENGTH OF THE DATA SPACE DEFINED ABOVE.
;**********************************************************

;fixed entry point for call from main logic control program
	JMP	Start

;IF YOU NEED MORE VARIABLE SPACE DEFINE IT HERE.

Start:

;if CHANGE is set to one, then the main logic control program will
;implement settings as defined in above data structure.
	MOV	BYTE PTR[CHANGE],1

;************************************************************
;here is a simple one line example to change the clock rate
;	MOV	BYTE PTR[CLOCKRATE],7

;************************************************************
;this is a more complex example that cycles through several
;different clock rates on successive capture cycles.
	PUSH	AX
	MOV	AL,BYTE PTR[CLOCKRATE]
	CMP	AL,15
	JGE	Reset
	INC	AL
	MOV	BYTE PTR[CLOCKRATE],AL
	JMP	Exit
Reset:
	MOV	BYTE PTR[CLOCKRATE],1
Exit:
	POP	AX
	RET
USEREND:

SUBRT2	 ENDP
C2SEG	 ENDS
	 END
